"""
Surface functionality for the Python C loader.
"""
import sys
import imp
from . import loader

suffixes = [
	('.py.c', 'rb', None),
	('.py.m', 'rb', None),
	('.py.c++', 'rb', None),
]

# recognize .py.c, .py.m, and .py.c++ files.
_original_get_suffixes = imp.get_suffixes

def get_suffixes(*args, _suffixes = suffixes, **kw):
	sl = _original_get_suffixes()
	sl.extend(_suffixes)
	return sl

def install():
	'Install the meta path hook and override imp.get_suffixes'
	if loader.CLoader not in sys.meta_path:
		sys.meta_path.append(loader.CLoader)
		imp.get_suffixes = get_suffixes

def remove():
	'Remove the meta path hook.'
	sys.meta_path.remove(loader.CLoader)
	imp.get_suffixes = _original_get_suffixes
